#pragma once

#ifdef _WIN64
	#pragma comment(lib, "enigma_ide64.lib")
#else
	#pragma comment(lib, "enigma_ide.lib")
#endif

const int WM_PUBLIC         = 1;
const int WM_PRIVATE        = 2;

 // Number of crypted sections
const int  NUMBER_OF_CRYPTED_SECTIONS       = 16;

  // Crypt hash types, possible hash values for functions:
  // EP_CryptHashBuffer
  // EP_CryptHashStringA
  // EP_CryptHashStringW
  // EP_CryptHashFileA
  // EP_CryptHashFileW
const int HASH_XOR32        = 0;
const int HASH_MD2          = 1;
const int HASH_MD5          = 2;
const int HASH_RipeMD160    = 3;
const int HASH_SH1          = 4;
const int HASH_SHA224       = 5;
const int HASH_SHA256       = 6;
const int HASH_SHA384       = 7;
const int HASH_SHA512       = 8;

 // Return values of EP_RegLoadKey
const int LOADKEY_SUCCEEDED = 0;
const int LOADKEY_REGINFONOTFOUND = 1;
const int LOADKEY_NAMEBUFFERTOOSMALL = 2;
const int LOADKEY_KEYBUFFERTOOSMALL = 3;

 // Return values of EP_RegKeyStatus
const int KEY_STATUS_DOESNOTEXIST                         = 0;
const int KEY_STATUS_VALID                                = 1;
const int KEY_STATUS_INVALID                              = 2;
const int KEY_STATUS_STOLEN                               = 3;
const int KEY_STATUS_DATEEXPIRED                          = 4;
const int KEY_STATUS_WITHOUTHARDWARELOCK                  = 5;
const int KEY_STATUS_WITHOUTEXPIRATIONDATE                = 6;
const int KEY_STATUS_WITHOUTREGISTERAFTERDATE             = 7;
const int KEY_STATUS_WITHOUTREGISTERBEFOREDATE            = 8;
const int KEY_STATUS_WITHOUTEXECUTIONSLIMIT               = 9;
const int KEY_STATUS_WITHOUTDAYSLIMIT                     = 10;
const int KEY_STATUS_WITHOUTRUNTIMELIMIT                  = 11;
const int KEY_STATUS_WITHOUTGLOBALTIMELIMIT               = 12;
const int KEY_STATUS_WITHOUTCOUNTRYLOCK                   = 13;
const int KEY_STATUS_COUNTRYINVALID                       = 14;
const int KEY_STATUS_REGISTERAFTERFAILED                  = 15;
const int KEY_STATUS_REGISTERBEFOREFAILED                 = 16;
const int KEY_STATUS_EXECUTIONSEXPIRED                    = 17;
const int KEY_STATUS_DAYSEXPIRED                          = 18;
const int KEY_STATUS_RUNTIMEEXPIRED                       = 19;
const int KEY_STATUS_GLOBALTIMEEXPIRED                    = 20;
const int KEY_STATUS_HARDWARECHANGESEXCEEDED_VOLUMESERIAL = 21;
const int KEY_STATUS_HARDWARECHANGESEXCEEDED_VOLUMENAME   = 22;
const int KEY_STATUS_HARDWARECHANGESEXCEEDED_COMPUTERNAME = 23;
const int KEY_STATUS_HARDWARECHANGESEXCEEDED_CPU          = 24;
const int KEY_STATUS_HARDWARECHANGESEXCEEDED_MOTHERBOARD  = 25;
const int KEY_STATUS_HARDWARECHANGESEXCEEDED_WINDOWSKEY   = 26;
const int KEY_STATUS_HARDWARECHANGESEXCEEDED_HDDSERIAL    = 27;
const int KEY_STATUS_HARDWARECHANGESEXCEEDED_USERNAME     = 28;
const int KEY_STATUS_HARDWAREINVALID                      = 29;

  // Counties code
const int CN_AFGHANISTAN = 114;
const int CN_ALBANIA = 1;
const int CN_ALGERIA = 2;
const int CN_ARGENTINA = 3;
const int CN_ARMENIA = 4;
const int CN_AUSTRALIA = 5;
const int CN_AUSTRIA = 6;
const int CN_AZERBAIJAN = 7;
const int CN_BAHRAIN = 8;
const int CN_BANGLADESH = 115;
const int CN_BELARUS = 9;
const int CN_BELGIUM = 10;
const int CN_BELIZE = 11;
const int CN_BOLIVIA = 116;
const int CN_BOSNIA = 117;
const int CN_BRAZIL = 13;
const int CN_BRUNEI = 14;
const int CN_BULGARIA = 15;
const int CN_CAMBODIA = 16;
const int CN_CANADA = 17;
const int CN_CARRIBEAN = 118;
const int CN_CHILE = 20;
const int CN_CHINA = 21;
const int CN_COLOMBIA = 22;
const int CN_COSTARICA = 23;
const int CN_CROATIA = 24;
const int CN_CZECH = 25;
const int CN_DENMARK = 26;
const int CN_DOMINICAN = 27;
const int CN_ECUADOR = 28;
const int CN_EGYPT = 29;
const int CN_ELSALVADOR = 30;
const int CN_ESTONIA = 31;
const int CN_ETHIOPIA = 119;
const int CN_FAROE = 32;
const int CN_FINLAND = 33;
const int CN_FRANCE = 34;
const int CN_GEORGIA = 35;
const int CN_GERMANY = 36;
const int CN_GREECE = 37;
const int CN_GREENLAND = 120;
const int CN_GUATEMALA = 38;
const int CN_HONDURAS = 39;
const int CN_HONGKONG = 40;
const int CN_HUNGARU = 41;
const int CN_ICELAND = 42;
const int CN_INDIA = 43;
const int CN_INDONESIA = 44;
const int CN_IRAN = 45;
const int CN_IRAQ = 46;
const int CN_IRELAND = 47;
const int CN_ISRAEL = 48;
const int CN_ITALY = 49;
const int CN_JAMAICA = 50;
const int CN_JAPAN = 51;
const int CN_JORDAN = 52;
const int CN_KAZAKHSTAN = 53;
const int CN_KENYA = 54;
const int CN_KOREA = 56;
const int CN_KUWAIT = 57;
const int CN_KYRGYZSTAN = 58;
const int CN_LAOS = 121;
const int CN_LATVIA = 59;
const int CN_LEBANON = 60;
const int CN_LIBYAN = 122;
const int CN_LIECHTENSTEIN = 62;
const int CN_LITHUANIA = 63;
const int CN_LUXEMBOURG = 64;
const int CN_MACAO = 65;
const int CN_MACEDONIA = 66;
const int CN_MALAYSIA = 67;
const int CN_MALDIVES = 123;
const int CN_MALTA = 124;
const int CN_MEXOCI = 68;
const int CN_MONACO = 70;
const int CN_MONGOLIA = 71;
const int CN_MONTENEGRO = 125;
const int CN_MOROCCO = 72;
const int CN_NEPAL = 126;
const int CN_NETHERLANDS = 73;
const int CN_NEWZEALAND = 74;
const int CN_NICARAGUA = 75;
const int CN_NIGERIA = 127;
const int CN_NORWAY = 76;
const int CN_OMAN = 77;
const int CN_PAKISTAN = 78;
const int CN_PANAMA = 79;
const int CN_PARAGUAY = 80;
const int CN_PERY = 81;
const int CN_PHILIPPINES = 82;
const int CN_POLAND = 83;
const int CN_PORTUGAL = 84;
const int CN_PUERTORICO = 85;
const int CN_QATAR = 86;
const int CN_ROMANIA = 87;
const int CN_RUSSIA = 88;
const int CN_RWANDA = 128;
const int CN_SAUDIARABIA = 89;
const int CN_SENEGAL = 129;
const int CN_SERBIA = 130;
const int CN_SERBIAMONTENEGRO = 90;
const int CN_SINGAROPE = 91;
const int CN_SLOVAKIA = 92;
const int CN_SLOVENIA = 93;
const int CN_SOUTHAFRICA = 94;
const int CN_SPAIN = 95;
const int CN_SRILANKA = 131;
const int CN_SWEDEN = 96;
const int CN_SWITZERLAND = 97;
const int CN_SYRIAN = 132;
const int CN_TAIWAN = 98;
const int CN_TAJIKISTAN = 99;
const int CN_THAILAND = 100;
const int CN_TRINIDADTOBAGO = 101;
const int CN_TUNISIA = 102;
const int CN_TURKEY = 103;
const int CN_TURKMENISTAN = 133;
const int CN_UKRAINE = 104;
const int CN_UAE = 105;
const int CN_UNITEDKINGDOM = 106;
const int CN_USA = 107;
const int CN_URUGUAY = 108;
const int CN_UZBEKISTAN = 109;
const int CN_VENEZUELA = 110;
const int CN_VIETNAM = 111;
const int CN_YEMEN = 112;
const int CN_ZIMBABWE = 113;

// Return results of the functions EP_RegEncryptRegistrationInformation and
// EP_RegDecryptRegistrationInformation
const int REG_CRYPT_OK                       = 0;
const int REG_CRYPT_INVALID                  = 1;
const int REG_CRYPT_INSUFFICIENT_BUFFER      = 2;
const int REG_CRYPT_INSUFFICIENT_NAME_BUFFER = 3;
const int REG_CRYPT_INSUFFICIENT_KEY_BUFFER  = 4;

#pragma pack(push, 4)

typedef struct _TKeyCountries
{
  char* Name;
  int Code;
} TKeyCountries, *PKeyCountries;

const TKeyCountries KEY_COUNTRIES[127] =
{
  (char*)"Afghanistan"               , CN_AFGHANISTAN      ,
  (char*)"Albania"                   , CN_ALBANIA          ,
  (char*)"Algeria"                   , CN_ALGERIA          ,
  (char*)"Argentina"                 , CN_ARGENTINA        ,
  (char*)"Armenia"                   , CN_ARMENIA          ,
  (char*)"Australia"                 , CN_AUSTRALIA        ,
  (char*)"Austria"                   , CN_AUSTRIA          ,
  (char*)"Azerbaijan"                , CN_AZERBAIJAN       ,
  (char*)"Bahrain"                   , CN_BAHRAIN          ,
  (char*)"Bangladesh"                , CN_BANGLADESH       ,
  (char*)"Belarus"                   , CN_BELARUS          ,
  (char*)"Belgium"                   , CN_BELGIUM          ,
  (char*)"Belize"                    , CN_BELIZE           ,
  (char*)"Bolivia"                   , CN_BOLIVIA          ,
  (char*)"Bosnia and Herzegovina"    , CN_BOSNIA           ,
  (char*)"Brazil"                    , CN_BRAZIL           ,
  (char*)"Brunei Darussalam"         , CN_BRUNEI           ,
  (char*)"Bulgaria"                  , CN_BULGARIA         ,
  (char*)"Cambodia"                  , CN_CAMBODIA         ,
  (char*)"Canada"                    , CN_CANADA           ,
  (char*)"Caribbean"                 , CN_CARRIBEAN        ,
  (char*)"Chile"                     , CN_CHILE            ,
  (char*)"China"                     , CN_CHINA            ,
  (char*)"Colombia"                  , CN_COLOMBIA         ,
  (char*)"Costa Rica"                , CN_COSTARICA        ,
  (char*)"Croatia"                   , CN_CROATIA          ,
  (char*)"Czech Republic"            , CN_CZECH            ,
  (char*)"Denmark"                   , CN_DENMARK          ,
  (char*)"Dominican Republic"        , CN_DOMINICAN        ,
  (char*)"Ecuador"                   , CN_ECUADOR          ,
  (char*)"Egypt"                     , CN_EGYPT            ,
  (char*)"El Salvador"               , CN_ELSALVADOR       ,
  (char*)"Estonia"                   , CN_ESTONIA          ,
  (char*)"Ethiopia"                  , CN_ETHIOPIA         ,
  (char*)"Faroe Islands"             , CN_FAROE            ,
  (char*)"Finland"                   , CN_FINLAND          ,
  (char*)"France"                    , CN_FRANCE           ,
  (char*)"Georgia"                   , CN_GEORGIA          ,
  (char*)"Germany"                   , CN_GERMANY          ,
  (char*)"Greece"                    , CN_GREECE           ,
  (char*)"Greenland"                 , CN_GREENLAND        ,
  (char*)"Guatemala"                 , CN_GUATEMALA        ,
  (char*)"Honduras"                  , CN_HONDURAS         ,
  (char*)"Hong Kong"                 , CN_HONGKONG         ,
  (char*)"Hungary"                   , CN_HUNGARU          ,
  (char*)"Iceland"                   , CN_ICELAND          ,
  (char*)"India"                     , CN_INDIA            ,
  (char*)"Indonesia"                 , CN_INDONESIA        ,
  (char*)"Iran"                      , CN_IRAN             ,
  (char*)"Iraq"                      , CN_IRAQ             ,
  (char*)"Ireland"                   , CN_IRELAND          ,
  (char*)"Israel"                    , CN_ISRAEL           ,
  (char*)"Italy"                     , CN_ITALY            ,
  (char*)"Jamaica"                   , CN_JAMAICA          ,
  (char*)"Japan"                     , CN_JAPAN            ,
  (char*)"Jordan"                    , CN_JORDAN           ,
  (char*)"Kazakhstan"                , CN_KAZAKHSTAN       ,
  (char*)"Kenya"                     , CN_KENYA            ,
  (char*)"Korea"                     , CN_KOREA            ,
  (char*)"Kuwait"                    , CN_KUWAIT           ,
  (char*)"Kyrgyzstan"                , CN_KYRGYZSTAN       ,
  (char*)"Laos"                      , CN_LAOS             ,
  (char*)"Latvia"                    , CN_LATVIA           ,
  (char*)"Lebanon"                   , CN_LEBANON          ,
  (char*)"Libyan"                    , CN_LIBYAN           ,
  (char*)"Liechtenstein"             , CN_LIECHTENSTEIN    ,
  (char*)"Lithuania"                 , CN_LITHUANIA        ,
  (char*)"Luxembourg"                , CN_LUXEMBOURG       ,
  (char*)"Macao"                     , CN_MACAO            ,
  (char*)"Macedonia"                 , CN_MACEDONIA        ,
  (char*)"Malaysia"                  , CN_MALAYSIA         ,
  (char*)"Maldives"                  , CN_MALDIVES         ,
  (char*)"Malta"                     , CN_MALTA            ,
  (char*)"Mexico"                    , CN_MEXOCI           ,
  (char*)"Monaco"                    , CN_MONACO           ,
  (char*)"Mongolia"                  , CN_MONGOLIA         ,
  (char*)"Montenegro"                , CN_MONTENEGRO       ,
  (char*)"Morocco"                   , CN_MOROCCO          ,
  (char*)"Nepal"                     , CN_NEPAL            ,
  (char*)"Netherlands"               , CN_NETHERLANDS      ,
  (char*)"New Zealand"               , CN_NEWZEALAND       ,
  (char*)"Nicaragua"                 , CN_NICARAGUA        ,
  (char*)"Nigeria"                   , CN_NIGERIA          ,
  (char*)"Norway"                    , CN_NORWAY           ,
  (char*)"Oman"                      , CN_OMAN             ,
  (char*)"Pakistan"                  , CN_PAKISTAN         ,
  (char*)"Panama"                    , CN_PANAMA           ,
  (char*)"Paraguay"                  , CN_PARAGUAY         ,
  (char*)"Peru"                      , CN_PERY             ,
  (char*)"Philippines"               , CN_PHILIPPINES      ,
  (char*)"Poland"                    , CN_POLAND           ,
  (char*)"Portugal"                  , CN_PORTUGAL         ,
  (char*)"Puerto Rico"               , CN_PUERTORICO       ,
  (char*)"Qatar"                     , CN_QATAR            ,
  (char*)"Romania"                   , CN_ROMANIA          ,
  (char*)"Russia"                    , CN_RUSSIA           ,
  (char*)"Rwanda"                    , CN_RWANDA           ,
  (char*)"Saudi Arabia"              , CN_SAUDIARABIA      ,
  (char*)"Senegal"                   , CN_SENEGAL          ,
  (char*)"Serbia"                    , CN_SERBIA           ,
  (char*)"Serbia and Montenegro"     , CN_SERBIAMONTENEGRO ,
  (char*)"Singapore"                 , CN_SINGAROPE        ,
  (char*)"Slovakia"                  , CN_SLOVAKIA         ,
  (char*)"Slovenia"                  , CN_SLOVENIA         ,
  (char*)"South Africa"              , CN_SOUTHAFRICA      ,
  (char*)"Spain"                     , CN_SPAIN            ,
  (char*)"Sri Lanka"                 , CN_SRILANKA         ,
  (char*)"Sweden"                    , CN_SWEDEN           ,
  (char*)"Switzerland"               , CN_SWITZERLAND      ,
  (char*)"Syrian"                    , CN_SYRIAN           ,
  (char*)"Taiwan"                    , CN_TAIWAN           ,
  (char*)"Tajikistan"                , CN_TAJIKISTAN       ,
  (char*)"Thailand"                  , CN_THAILAND         ,
  (char*)"Trinidad and Tobago"       , CN_TRINIDADTOBAGO   ,
  (char*)"Tunisia"                   , CN_TUNISIA          ,
  (char*)"Turkey"                    , CN_TURKEY           ,
  (char*)"Turkmenistan"              , CN_TURKMENISTAN     ,
  (char*)"Ukraine"                   , CN_UKRAINE          ,
  (char*)"United Arab Emirates"      , CN_UAE              ,
  (char*)"United Kingdom"            , CN_UNITEDKINGDOM    ,
  (char*)"United States"             , CN_USA              ,
  (char*)"Uruguay"                   , CN_URUGUAY          ,
  (char*)"Uzbekistan"                , CN_UZBEKISTAN       ,
  (char*)"Venezuela"                 , CN_VENEZUELA        ,
  (char*)"Viet Nam"                  , CN_VIETNAM          ,
  (char*)"Yemen"                     , CN_YEMEN            ,
  (char*)"Zimbabwe"                  , CN_ZIMBABWE
};

typedef struct TWMContent {

    int   WMType;
    char* Name;
    int   NameLen;
    char* Text;
    int   TextLen;
    char* FileName;
    int   FileNameLen;
    char* AFile;
    int   AFileLen;

} TWMContent, *PWMContent;

typedef struct TKeyInformation {
    bool Stolen;               // {out} is key stolen
    int CreationYear;        // {out} key creation year
    int CreationMonth;       // {out} key creation month
    int CreationDay;         // {out} key creation day
    bool UseKeyExpiration;     // {out} has key expiration date?
    int ExpirationYear;      // {out} key expiration year
    int ExpirationMonth;     // {out} key expiration month
    int ExpirationDay;       // {out} key expiration day
    bool UseHardwareLocking;   // {out} hardware locked key
    bool UseExecutionsLimit;   // {out} limit key by executions?
    int ExecutionsCount;     // {out} number of executions
    bool UseDaysLimit;         // {out} limit key by days?
    int DaysCount;           // {out} number of days
    bool UseRunTimeLimit;      // {out} limit key by run time?
    int RunTimeMinutes;      // {out} run time minutes
    bool UseGlobalTimeLimit;   // {out} limit key by global time?
    int GlobalTimeMinutes;   // {out} global time minutes
    bool UseCountyLimit;       // {out} limit key by country?
    int CountryCode;         // {out} country code
    bool UseRegisterAfter;     // {out} register key after date?
    int RegisterAfterYear;   // {out} register after year
    int RegisterAfterMonth;  // {out} register after month
    int RegisterAfterDay;    // {out} register after day
    bool UseRegisterBefore;    // {out} register key before date?
    int RegisterBeforeYear;  // {out} register before year
    int RegisterBeforeMonth; // {out} register before month
    int RegisterBeforeDay;   // {out} register before day
    bool EncryptedSections[NUMBER_OF_CRYPTED_SECTIONS]; // {out} Crypted sections
} TKeyInformation, *PKeyInformation;

#pragma pack(pop)

#ifdef __cplusplus
extern "C" {
#endif

// Markers API
__declspec(dllimport) void __stdcall EP_Marker(const char*);

// Registration API
__declspec(dllimport) bool __stdcall EP_RegSaveKey(const char* Name, const char* Key);
__declspec(dllimport) bool __stdcall EP_RegSaveKeyA(const char* Name, const char* Key);
__declspec(dllimport) bool __stdcall EP_RegSaveKeyW(const wchar_t* Name, const wchar_t* Key);
__declspec(dllimport) bool __stdcall EP_RegLoadKey(char** Name, char** Key);
__declspec(dllimport) bool __stdcall EP_RegLoadKeyA(char** Name, char** Key);
__declspec(dllimport) bool __stdcall EP_RegLoadKeyW( wchar_t** Name, wchar_t** Key );
__declspec(dllimport) int __stdcall EP_RegLoadKeyEx( const char* Name, int* NameLen, const char* Key, int* KeyLen);
__declspec(dllimport) bool __stdcall EP_RegCheckKey(const char* Name, const char* Key);
__declspec(dllimport) bool __stdcall EP_RegCheckKeyA(const char* Name, const char* Key);
__declspec(dllimport) bool __stdcall EP_RegCheckKeyW(const wchar_t* Name, const wchar_t* Key);
__declspec(dllimport) bool __stdcall EP_RegDeleteKey();
__declspec(dllimport) bool __stdcall EP_RegLoadAndCheckKey();
__declspec(dllimport) bool __stdcall EP_RegCheckAndSaveKey(const char* Name, const char* Key);
__declspec(dllimport) bool __stdcall EP_RegCheckAndSaveKeyA(const char* Name, const char* Key);
__declspec(dllimport) bool __stdcall EP_RegCheckAndSaveKeyW( const wchar_t* Name, const wchar_t* Key );

__declspec(dllimport) char*  __stdcall EP_RegHardwareID();
__declspec(dllimport) char* __stdcall EP_RegHardwareIDA();
__declspec(dllimport) wchar_t* __stdcall EP_RegHardwareIDW();

__declspec(dllimport) bool __stdcall EP_RegKeyCreationDate(int* Year, int* Month, int* Day);
__declspec(dllimport) bool __stdcall EP_RegKeyExpirationDate( int* Year, int* Month, int* Day );
__declspec(dllimport) int __stdcall EP_RegKeyCreationDateEx();
__declspec(dllimport) int __stdcall EP_RegKeyExpirationDateEx();
__declspec(dllimport) bool __stdcall EP_RegKeyExecutions( int* Total, int* Left );
__declspec(dllimport) int __stdcall EP_RegKeyExecutionsTotal();
__declspec(dllimport) int __stdcall EP_RegKeyExecutionsLeft();
__declspec(dllimport) bool __stdcall EP_RegKeyDays( int* Total, int* Left );
__declspec(dllimport) int __stdcall EP_RegKeyDaysTotal();
__declspec(dllimport) int __stdcall EP_RegKeyDaysLeft();
__declspec(dllimport) bool __stdcall EP_RegKeyRuntime( int* Total, int* Left );
__declspec(dllimport) int __stdcall EP_RegKeyRuntimeTotal();
__declspec(dllimport) int __stdcall EP_RegKeyRuntimeLeft();
__declspec(dllimport) bool __stdcall EP_RegKeyGlobalTime( int* Total, int* Left );
__declspec(dllimport) int __stdcall EP_RegKeyGlobalTimeTotal();
__declspec(dllimport) int __stdcall EP_RegKeyGlobalTimeLeft();
__declspec(dllimport) bool __stdcall EP_RegKeyRegisterAfterDate( int* Year, int* Month, int* Day );
__declspec(dllimport) int __stdcall EP_RegKeyRegisterAfterDateEx();
__declspec(dllimport) bool __stdcall EP_RegKeyRegisterBeforeDate( int* Year, int* Month, int* Day );
__declspec(dllimport) int __stdcall EP_RegKeyRegisterBeforeDateEx();
__declspec(dllimport) bool __stdcall EP_RegKeyInformation(const char* AName, const char* AKey, PKeyInformation AKeyInfo);
__declspec(dllimport) bool __stdcall EP_RegKeyInformationA(const char* AName, const char* AKey, PKeyInformation AKeyInfo);
__declspec(dllimport) bool __stdcall EP_RegKeyInformationW(const wchar_t* AName, const wchar_t* AKey, PKeyInformation AKeyInfo);
__declspec(dllimport) int __stdcall EP_RegKeyStatus();
__declspec(dllimport) void __stdcall EP_RegShowDialog();
__declspec(dllimport) int __stdcall EP_RegEncryptRegistrationInformation(const char* ABuffer, int* ABufferSize, const char* ARegName, int ARegNameLen, const char* ARegKey, int ARegKeyLen);
__declspec(dllimport) int __stdcall EP_RegDecryptRegistrationInformation(const char* ABuffer, int ABufferSize, const char* ARegName, int* ARegNameLen, const char* ARegKey, int* ARegKeyLen);

// Enigma Online Activation API
__declspec(dllimport) void __stdcall EP_ActivationShowDialog();
__declspec(dllimport) bool __stdcall EP_ActivationActivate();
__declspec(dllimport) bool __stdcall EP_ActivationActivateWithId(const char* ActivationId);
__declspec(dllimport) bool __stdcall EP_ActivationActivateWithIdA(const char* ActivationId);
__declspec(dllimport) bool __stdcall EP_ActivationActivateWithIdW(const wchar_t* ActivationId);
__declspec(dllimport) bool __stdcall EP_ActivationDeactivate();
__declspec(dllimport) bool __stdcall EP_ActivationDeactivateWithId(const char* ActivationId);
__declspec(dllimport) bool __stdcall EP_ActivationDeactivateWithIdA(const char* ActivationId);
__declspec(dllimport) bool __stdcall EP_ActivationDeactivateWithIdW(const wchar_t* ActivationId);

// Trial API
__declspec(dllimport) bool __stdcall EP_TrialExecutions( int* Total, int* Left );
__declspec(dllimport) int __stdcall EP_TrialExecutionsTotal();
__declspec(dllimport) int __stdcall EP_TrialExecutionsLeft();
__declspec(dllimport) bool __stdcall EP_TrialDays( int* Total, int* Left );
__declspec(dllimport) int __stdcall EP_TrialDaysTotal();
__declspec(dllimport) int __stdcall EP_TrialDaysLeft();
__declspec(dllimport) bool __stdcall EP_TrialExpirationDate( int* Year, int* Month, int* Day );
__declspec(dllimport) int __stdcall EP_TrialExpirationDateEx();
__declspec(dllimport) bool __stdcall EP_TrialDateTillDate( int* StartYear, int* StartMonth, int* StartDay, int* EndYear, int* EndMonth, int* EndDay );
__declspec(dllimport) int __stdcall EP_TrialDateTillDateStartEx();
__declspec(dllimport) int __stdcall EP_TrialDateTillDateEndEx();
__declspec(dllimport) bool __stdcall EP_TrialExecutionTime( int* Total, int* Left );
__declspec(dllimport) int __stdcall EP_TrialExecutionTimeTotal();
__declspec(dllimport) int __stdcall EP_TrialExecutionTimeLeft();
__declspec(dllimport) int __stdcall EP_TrialClockReversedDays();

// Misc API
__declspec(dllimport) int __stdcall EP_MiscGetWatermark( int ID, PWMContent WM );
__declspec(dllimport) int __stdcall EP_MiscCountryCode();

// Protection API
__declspec(dllimport) int __stdcall EP_ProtectedStringByID( int ID, const char* Str, int Len);
__declspec(dllimport) int __stdcall EP_ProtectedStringByKey( const char* Key, const char* Str, int Len);

// Crypt API
__declspec(dllimport) int __stdcall EP_CryptHashBuffer( int Hash, const char* Buffer, int Size, const char* Digest);
__declspec(dllimport) int __stdcall EP_CryptHashFileA( int Hash, const char* FileName, const char* Digest);
__declspec(dllimport) int __stdcall EP_CryptHashFileW( int Hash, const wchar_t* FileName, const char* Digest);
__declspec(dllimport) int __stdcall EP_CryptHashStringA( int Hash, const char* Str, const char* Digest);
__declspec(dllimport) int __stdcall EP_CryptHashStringW( int Hash, const wchar_t* Str, const char* Digest);
__declspec(dllimport) void __stdcall EP_CryptEncryptBuffer( const char* Buffer, int Size, const char* Key);
__declspec(dllimport) void __stdcall EP_CryptEncryptBufferEx( const char* InBuffer, const char* OutBuffer, int Size, const char* Key, int KeySize);
__declspec(dllimport) void __stdcall EP_CryptDecryptBuffer( const char* Buffer, int Size, const char* Key);
__declspec(dllimport) void __stdcall EP_CryptDecryptBufferEx( const char* InBuffer, const char* OutBuffer, int Size, const char* Key, int KeySize);

// Checkup API
__declspec(dllimport) bool __stdcall EP_CheckupCopies( int* Total, int* Current);
__declspec(dllimport) int __stdcall EP_CheckupCopiesTotal();
__declspec(dllimport) int __stdcall EP_CheckupCopiesCurrent();
__declspec(dllimport) bool __stdcall EP_CheckupIsProtected();
__declspec(dllimport) bool __stdcall EP_CheckupIsEnigmaOk();
__declspec(dllimport) bool __stdcall EP_CheckupFindProcess(const char* FileName, const char* WindowText, const char* WindowClass);
__declspec(dllimport) bool __stdcall EP_CheckupFindProcessA(const char* FileName, const char* WindowText, const char* WindowClass);
__declspec(dllimport) bool __stdcall EP_CheckupFindProcessW(const wchar_t* FileName, const wchar_t* WindowText, const wchar_t* WindowClass);
__declspec(dllimport) bool __stdcall EP_CheckupVirtualizationTools();

// Enigma API
__declspec(dllimport) int __stdcall EP_EnigmaVersion();

// Splash screen
__declspec(dllimport) int __stdcall EP_SplashScreenShow();
__declspec(dllimport) void __stdcall EP_SplashScreenHide();

#ifdef __cplusplus
}
#endif


